// NumericFormatDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Custom numeric format.h"
#include "NumericFormatDlg.h"

#include "NumFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNumericFormatDlg dialog
// Instances for formatting

static LPCTSTR aInstances[] = 
{
    _T("0"),
    _T("0.00"),
    _T("#,###"),
    _T("#,###.00"),
    _T("#,###;[Red]#,###"),
    _T("$#,##0;~($#,##0)"),
    _T("$#,##0;~[Red]($#,##0)"),
    _T("$#,##0.00;~($#,##0.00)"),
    _T("$#,##0.00;~[Red]($#,##0.00)"),
	_T("[>1000]#,###"),
    _T("[>=1000][Blue]#,###;[<0][Red]#,###;#,###"),
    _T("[>=1000][<=2000][Green]#,###;#,###"),
    _T("0%"),
    _T("0.00%"),
    NULL,
};

CNumericFormatDlg::CNumericFormatDlg(CNumericFormat* pnf, CWnd* pParent /*=NULL*/)
	: CDialog(CNumericFormatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNumericFormatDlg)
	m_sFormat = _T("");
	m_sListItem = _T("");
	//}}AFX_DATA_INIT

    m_pnf = pnf;
    m_sFormat = m_pnf->GetFormat();
}


void CNumericFormatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNumericFormatDlg)
	DDX_Control(pDX, IDC_NUM_FORMAT, m_cFormat);
	DDX_Control(pDX, IDC_NUM_FORMAT_INST, m_cList);
	DDX_Text(pDX, IDC_NUM_FORMAT, m_sFormat);
	DDX_LBString(pDX, IDC_NUM_FORMAT_INST, m_sListItem);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNumericFormatDlg, CDialog)
	//{{AFX_MSG_MAP(CNumericFormatDlg)
	ON_LBN_SELCHANGE(IDC_NUM_FORMAT_INST, OnSelchangeNumFormatInst)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNumericFormatDlg message handlers

BOOL CNumericFormatDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
    LPCTSTR* pInst = aInstances;
    while(*pInst)
        m_cList.AddString(*pInst++);

    m_cFormat.LimitText(MAX_NFORMAT_LEN - 10);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CNumericFormatDlg::OnSelchangeNumFormatInst() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
    m_sFormat = m_sListItem;
    UpdateData(FALSE);
}

void CNumericFormatDlg::OnOK() 
{
	// TODO: Add extra validation here
	CDialog::OnOK();

    m_pnf->SetFormat(m_sFormat);
}
